#ifndef SCREENBUTTON_H
#define SCREENBUTTON_H

#include <QString>
#include <plasma/widgets/frame.h>
#include <plasma/widgets/iconwidget.h>

class QGraphicsWidget;
class QGraphicsLinearLayout;


class ScreenButton : public Plasma::Frame
{
    Q_OBJECT
public:
    ScreenButton(const QString &label, QGraphicsWidget *parent);
    void disable();
    bool isEnabled();


private:
    Plasma::IconWidget* m_label;
    QGraphicsLinearLayout* m_layout;
    bool enabled;

public Q_SLOTS:
    void enable();
};

#endif // SCREENBUTTON_H
