#ifndef THUMBNAILICON_H
#define THUMBNAILICON_H

#include <Plasma/IconWidget>

class QUrl;

class KWebThumbnailer;

class ThumbnailIcon : public Plasma::IconWidget
{
    Q_OBJECT

public:
    ThumbnailIcon( QGraphicsWidget *parent );
    void setUrl( const QUrl &url );

    // DEBUG ONLY
    //    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

public slots:
    void start();
    void thumbnailFinished( bool ok );
  
private:
    QUrl url;
    KWebThumbnailer *thumbnailer;
};

#endif // THUMBNAILICON_H

