#!/usr/bin/env kross
=begin
# -*- coding utf-8 -*-
#/*
# * Copyright(c) 2008 Matthew Adams <roguestar191 at comcast.net>
# *
# * This program is free software; you can redistribute it and/or
# * modify it under the terms of the GNU General Public License as
# * published by the Free Software Foundation; either version 2 of
# * the License, or(at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this program.  If not, see <http//www.gnu.org/licenses/>.
# */

# Rdale, THANK YOU ! He did a crapload of work on the ruby bindings afaik
#
# Some parts shamelessly stolen (borrowed) and brutally chopped up from the plasmoid examples in kde
# 
# The base is PlasmaScripting::Applet. On top of that is my applet - which draws it's text to the applet
# What a pain in the ass
# Anyway, work like the clock to resize properly
# Grab mouse clicks, open dialog
# Create the dialog, populate it 
# On click move dialog and show it - only move the first time
# Dialogs should be resizeable - but plasma seems to have disabled this in 4.2beta2
#
#
=end

require 'korundum4'
require 'Qt'


#require 'Qt4'
#require 'thread'
# The actual UI. All the ui MUST contain is freqlistview and govlistview, cpulistview, and gpllabel, don't let their names decieve you
# They're not listview's, they're listwidgets. 
require 'plasma_applet'
module RubyWelcome
require 'Ui_Dialog'
require 'Ui_About'
require 'gpl.rb'
require 'MyDialogHelper'
require 'TipDatabase'
require 'qtwebkit'


class WebViewProxy < Qt::GraphicsProxyWidget
	   def initialize(parent, dialog)
		super(parent)
		@c = dialog
		removeEventFilter(dialog)
		parent.removeEventFilter(self)	
	   end
end


# Now the heart of the program
        class Main < PlasmaScripting::Applet
	        attr_accessor	:objectName
	        attr_reader	:mywidget
		attr_accessor	:mydir

	   def getTip()
		if(@tipdb.isHtml() == false)
			return @tipdb.tip()
		end
		return @tipdb.tip()
	   end
	   def nextTip()
		@tipdb.nextTip()
		return getTip()
	   end
	   def prevTip()
		@tipdb.prevTip()
		return getTip()
	   end
	   def loadConfig
		begin
			ftipr = File.dirname(@mydir)	
			f = File.open( "%s/config" % ftipr, 'r')
			config = Marshal.load(f)
			@tipfile = config[0]
			f.close()
		rescue
			puts "Loading default config"
			ftipr = File.dirname(@mydir)
			ftip = ftipr + "/tips"
			@tipfile = ftip		
			writeConfig()
			
	   	end
	   end	
           def writeConfig()
		ftipr = File.dirname(@mydir)
		f = File.open( "%s/config" % ftipr, 'w')
		config = [@tipfile]
		Marshal.dump(config, f)
		f.close()
	   end
	   def applet()
		return @top.applet()
	   end
           def initialize(parent,args=nil)
                super
		@mydir = File.dirname(__FILE__)
		@top = parent
		@parent = parent
		puts Dir.pwd()
		GC.disable

		loadConfig()
		@tipdb = TipDatabase.new(@tipfile)
		
		@activeCpu = 0
		@svg = nil

           end
	# Init function, create everything
	    def setTipFile(tfile)
		if(tfile[0, 6] == 'file:/')
			tfile = tfile[5, tfile.length()-5]
		end
		@tipdb = TipDatabase.new(tfile)
		@tipfile = tfile
		writeConfig()
	   end
           def init
		

		@fm = Qt::FontMetrics.new(Qt::Application.font)
		#resize
		metrics = Qt::FontMetricsF.new(KDE::GlobalSettings.smallestReadableFont)
		@Text = '  Welcome Dialog  '
		@minsize = metrics.size(Qt::TextSingleLine, @Text)
		@minsize = @minsize * 2

		@watermark = Plasma::Svg.new()
		ftipr = @mydir[0,@mydir.length()-5]
		watermarkimage = ftipr+"/images/kde_watermark.svg"
		puts 'Watermark dir: ' + watermarkimage
		@watermark.setImagePath(watermarkimage)

		setMinimumSize(@minsize)
		@c = MyHelperDialog.new(nil,@top.applet(),self)
                setupUi()
		@c.settop(self, @top.applet())

		if(@c.isPlasma() == false)
	                @proxy = WebViewProxy.new(@top.applet(), @c)
	                @layout = Qt::GraphicsLinearLayout.new(@top.applet())

		        @proxy.setWidget(@c)
	        	@layout.addItem(@proxy)
		else
			@c.hide() # If we have a plasma based ver we don't need the proxy so we can hide the dialog because
			# everything is drawn onto the applet..
		end
		@c.dialog.motdlabel.setHtml(getTip())
		resizeme(@c.dialog.gridLayout.contentsRect().width, @c.dialog.gridLayout.contentsRect().height())
		self.show()
           end

	   def resizeme(x, y)
		resize(x, y)
		if @c.isPlasma == false
			@proxy.resize(x,y)
		end
		setMinimumWidth(x)
		setMinimumHeight(y)
	   end
           def paintInterface( p, option, rect)
		# draw the watermark.
		height = size().height()/4
		@watermarkheight = @watermark.size.height
		diff = height-@watermarkheight
		width = @watermark.size.width+diff
		@watermark.resize(height, width)
		@watermark.paint(p, size().width/2-@watermark.size.width/2, size().height/2-@watermark.size.height/2)
		return false
		
	   end
           def setupUi()
		# It does need a configuration dialog imo, set default tab, set the strings for the command launchers
		# at least..
           end
        end
end

