/**
 * @file   red.h
 * @author Adenilson Cavalcanti
 * @date   Thu Feb 25 06:59:49 2010
 * 
 * @brief  
 * 
 * 
 */

#ifndef __RED__
#define __RED__

#include <QString>
#include <QPixmap>
#include <QGraphicsWidget>

class RedWidget : public QGraphicsWidget
{
Q_OBJECT

public:
    RedWidget(QGraphicsItem * parent = 0, Qt::WindowFlags wFlags = 0);

    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget=0);

    void mousePressEvent(QGraphicsSceneMouseEvent *event);

    void setIconPath(const QString &path);

Q_SIGNALS:
    void clicked();

private:

    QString icon;
    QPixmap pix;
};


#endif
