
#ifndef propertyeditor_h
#define propertyeditor_h

#include <QWidget>
#include <QSignalMapper>
#include "node.h"


class PropertyEditor : public QWidget
{
    Q_OBJECT

public:
    PropertyEditor(QWidget* parent = 0);
    void setNode(Quasar::Node* node);

signals:
    void propertyChanged();
    
private slots:
    void valueChanged(const QString& propName);

private:
    QWidget* createEditor(const QString& propName);

private:
    Quasar::Node* m_node;
    QSignalMapper m_signalMapper;
};

#endif
