#ifndef QUASAR_MESH_H
#define QUASAR_MESH_H

#include <texture.h>

#include <QtCore/QPointF>

namespace Quasar
{

    class Mesh
    {
    public:
        Mesh(const Texture &tex, int size);
        ~Mesh();

        int size() const;
        Texture texture() const;

        void render(const QPointF &pt=QPointF(0, 0));
    private:
        class Private;
        Private *d;
    };

}
#endif
