/* This file is part of the KDE project

   Copyright (C) 2005 Ramakrishna R <coolrama@gmail.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; version 2
   of the License.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; see the file COPYING.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Steet, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/


#ifndef _KLBPLUGIN_H_
#define _KLBPLUGIN_H_

#include <qstringlist.h>

#include <konq_popupmenu.h>
#include <kfileitem.h>
#include <kconfig.h>

class KAction;
class QSignalMapper;

class LabelMenu : public KonqPopupMenuPlugin {
  Q_OBJECT
public:
    LabelMenu( KonqPopupMenu *, const char *name, const QStringList & list );
//    virtual ~LabelMenu();

public slots:
    void slotklb(int ss);
 //   void slotCompressAs( int pos );
private:
//    KActionMenu *popup;
	KonqPopupMenu *popup;
	QStringList labelsList;   
 
/*    QString m_name, m_ext;
    KFileItemList m_list;
    KURL::List m_archiveList;
    QStringList m_archiveMimeTypes;
    QStringList m_extractMimeTypes;
    QStringList m_extensionList;
    KActionMenu * m_compAsMenu;
    KActionMenu * m_addToMenu;
    QSignalMapper * m_compAsMapper;
    QSignalMapper * m_addToMapper;
    KConfig * m_conf;
    QString m_dir; //contains the currect directory
*/
};

#endif

