/*****************************************************************************
 *   Copyright (C) 2008 by Ben Cooksley <ben@eclipse.endoftheinternet.org>   *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by    *
 *   the Free Software Foundation; either version 2 of the License, or       *
 *   (at your option) any later version.                                     *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU General Public License for more details.                            *
 *                                                                           *
 *   You should have received a copy of the GNU General Public License       *
 *   along with this program; if not, write to the                           *
 *   Free Software Foundation, Inc.,                                         *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .          *
 ****************************************************************************/

#ifndef QUIZSPLASH_H
#define QUIZSPLASH_H

#include <QGraphicsLinearLayout>

#include <plasma/widgets/groupbox.h>
#include <plasma/widgets/label.h>
#include <plasma/widgets/pushbutton.h>

class QuizSplash : public Plasma::GroupBox
{
    Q_OBJECT
public:
    QuizSplash(QGraphicsWidget *parent);
    Plasma::Label header;
    Plasma::Label resultsHeader;
    Plasma::Label results;
    Plasma::PushButton startQuiz;
    QGraphicsLinearLayout * layout;
};

#endif
