#ifndef SESSIONPLASMOID_H
#define SESSIONPLASMOID_H

// KDE
#include <KIcon>
// Plasma
#include <Plasma/Applet>
#include <Plasma/Svg>


namespace Plasma
{

class SessionPlasmoid : public Applet
{
  Q_OBJECT

  public:
    SessionPlasmoid( QObject* parent, const QVariantList& args );

    virtual ~SessionPlasmoid();

  public: // Plasma::Applet API
    virtual void paintInterface( QPainter* painter,
                const QStyleOptionGraphicsItem* option,
                const QRect& contentsRect);
    virtual void init();

  private:
    Svg mSvg;
    KIcon mIcon;
};

}

#endif
