#ifndef SHINYICON_H
#define SHINYICON_H

#include <QGraphicsWidget>

class QUrl;

class ShinyIcon : public QGraphicsWidget
{
    Q_OBJECT

public:
    ShinyIcon(QGraphicsItem *parent=0, Qt::WindowFlags wFlags=0);
    ~ShinyIcon();

    // For now this will be glued to the thumbnail stuff but should become
    // a standalone class later
    void setUrl( const QUrl &url );

public slots:
    void start();

private slots:
    void thumbnailFinished( bool ok );

private:
    class ShinyIconPrivate *d;
};

#endif // SHINYICON_H

