#ifndef WEBWATCHER_H
#define WEBWATCHER_H

#include <plasma/popupapplet.h>

namespace Plasma {
    class IconWidget;
};

class ThumbnailIcon;

class WebWatcher : public Plasma::PopupApplet
{
    Q_OBJECT

public:
    WebWatcher(QObject *parent, const QVariantList &args);
    ~WebWatcher();

    void init();

    QGraphicsWidget* graphicsWidget();

protected:
    QGraphicsLayoutItem *createThumbnailArea( QGraphicsWidget *parent );
    QGraphicsLayoutItem *createHeadlineArea( QGraphicsWidget *parent );

private:
    QGraphicsWidget *m_widget;
    ThumbnailIcon *m_thumbs[8];
};

K_EXPORT_PLASMA_APPLET(webwatcher, WebWatcher)

#endif // WEBWATCHER_H
