class TipBrowser < LinksTab
  def initialize(par=nil)
	super par
  end
  def createTipBrowserTab()
	@tipBrowserLayout = Qt::GraphicsGridLayout.new()
	@webFrame = TransparentFrame.new(@welcomePlasmoid, @transparentimage)
	
	@webFrame.objectName = "webFrame"
	@webToolsLayout = Qt::GraphicsLinearLayout.new(Qt::Horizontal,@webFrame)

	@webToolsLayout.spacing = 0

	@webFrame.setZValue(1);
	@backbutton = addToolNoLayout("go-previous")
	@forwardbutton = addToolNoLayout("go-next")
	@stopbut = addToolNoLayout("process-stop")
	@reloadbut = addToolNoLayout("view-refresh")

	@urlRequester = KDE::HistoryComboBox.new()
	@urlproxy = Url_Proxy.new(@urlRequester, nil)
	@urlRequester.setEditable(true)
	@urlRequester.setDuplicatesEnabled(false)
	@urlproxy.setZValue(999)
	@m_pixmapProvider = KDE::UrlPixmapProvider.new 
	@urlRequester.setPixmapProvider(@m_pixmapProvider)



	@webToolsLayout.addItem(@backbutton)#, 0, 0, 1, 1)
	@webToolsLayout.addItem(@forwardbutton)#, 0, 1, 1, 1)
	@webToolsLayout.addItem(@reloadbut)#, 0, 2, 1, 1)
	@webToolsLayout.addItem(@urlproxy)#, 1, 0, 1, 4)	
	@webToolsLayout.addItem(@stopbut)#, 0, 3, 1, 1)
	
	@hideWebToolsButtonProxy = Qt::GraphicsProxyWidget.new() 
	@hideWebToolsButton = KDE::ArrowButton.new()
	@hideWebToolsButtonProxy.setWidget(@hideWebToolsButton)

	@hideWebToolsButton.checkable = true
	@hideWebToolsButton.checked = true
	@hideWebToolsButton.maximumSize = Qt::Size.new(12, 12)
		
	
	@tipFrame = TransparentFrame.new(@welcomePlasmoid, @transparentimage)
	@tipToolsLayout = Qt::GraphicsLinearLayout.new(Qt::Horizontal,@tipFrame)

	@tipFileBox = Plasma::ComboBox.new(nil)
	@tipFileBox.setZValue(999)

	@mychildren<< @tipActionsLabel
	@mychildren<< @tipFileLabel


	@nextTipButton = addToolNoLayout("go-next-page")
	@prevTipButton = addToolNoLayout("go-previous-page")

	Qt::Object.connect(@nextTipButton.action, SIGNAL('triggered()'), self, SLOT('nextTip()'))
	Qt::Object.connect(@prevTipButton.action, SIGNAL('triggered()'), self, SLOT('prevTip()'))

	@tipToolsLayout.addItem(@prevTipButton)
	@tipToolsLayout.addItem(@nextTipButton)
	@tipToolsLayout.addItem(@tipFileBox)

	@tipToolsLayout.setAlignment(@tipToolsLayout,Qt::AlignCenter)

	
	@hideTipToolsButtonProxy = Qt::GraphicsProxyWidget.new()
	@hideTipToolsButton = KDE::ArrowButton.new()
	@hideTipToolsButtonProxy.setWidget(@hideTipToolsButton)
	@hideTipToolsButton.objectName = "hideTipToolsButton"
	@hideTipToolsButton.maximumSize = Qt::Size.new(12, 12)
	@hideTipToolsButton.checkable = true
	@hideTipToolsButton.checked = true

	@motdframe = TransparentFrame.new(@welcomePlasmoid, @transparentimage)
	@motdlayout = Qt::GraphicsLinearLayout.new(Qt::Vertical, @motdframe)
	@motdframe.setZValue(1)	

	@motdlabel = Plasma::WebView.new(@welcomePlasmoid)
	@motdlabel.setZValue(1)
	@motdlabel.objectName = "motdlabel"
	@motdlabel.setSizePolicy(Qt::SizePolicy::Expanding, Qt::SizePolicy::Expanding)
	@motdlabel.setUrl(KDE::Url.new("http://www.google.com/"))
	
	@motdlayout.addItem(@motdlabel)

	@m_zoom = Plasma::Slider.new();
    	@m_zoom.setMaximum(100);
	@m_zoom.setMinimum(0);
	@m_zoom.setValue(50);
	@m_zoom.setOrientation(Qt::Vertical);
	@m_zoom.show();

	Qt::Object.connect(@m_zoom, SIGNAL('sliderMoved(int)'), self, SLOT('zoom(int)'))
	Qt::Object.connect(@m_zoom, SIGNAL('valueChanged(int)'), self, SLOT('zoom(int)'))

	@webFrame.setZValue(999)
	@tipFrame.setZValue(999)

	@tipBrowserLayout.addItem(@motdframe,2,1,1,1)
	@tipBrowserLayout.addItem(@hideWebToolsButtonProxy, 1, 0, 1, 1)
	@tipBrowserLayout.addItem(@hideTipToolsButtonProxy, 0, 0, 1, 1)
	@tipBrowserLayout.addItem(@webFrame,1,1,1,1)
	@tipBrowserLayout.addItem(@tipFrame,0,1,1,1)
	#	@tipBrowserLayout.addItem(@m_progress) We need a progress bar dangit! Any kind will do..
	# add a slider here in a bit for zoomage
	@tipBrowserLayout.addItem(@m_zoom, 2,0,1,1)

    end
end
