#!/bin/sh

DIR="$KDE_SRC/kdebase/workspace/plasma/containments/desktop"

echo "Copying files from $DIR"
cp $DIR/*.cpp .
cp $DIR/*.h .

echo "Patching desktop.h & desktop.cpp"
sed -e 's/DefaultDesktop/ClutteredDesktop/g' -i desktop.cpp
sed -e 's/DefaultDesktop/ClutteredDesktop/g' -i desktop.h
sed -e 's/K_EXPORT_PLASMA_APPLET(desktop/K_EXPORT_PLASMA_APPLET(cluttereddesktop/' -i desktop.cpp
#sed -e 's/return actions;/actions.append(m_separator);\n    actions.append(m_settingsAction);\n    return actions;/' -i desktop.cpp

echo "Including cluttereddesktop.h & cluttereddesktop.cpp to desktop.h & desktop.cpp"
sed -e '/K_EXPORT_PLASMA_APPLET(cluttereddesktop/r cluttereddesktop.cpp' -e '//N' -i desktop.cpp
sed -e '/};$/r cluttereddesktop.h' -e '//N' -i desktop.h

