/***************************************************************************
 *   Copyright (C) 2009 by Wang Hoi <zealot.hoi@gmail.com>                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

#include "koratitem.h"

#include <QList>

namespace Korat
{

Item::Item(QGraphicsItem *parent)
    : QGraphicsWidget(parent)
{

}

Item::~Item()
{

}

bool Item::isContainer()
{
    return false;
}

QList<WeightList> Item::availableWidths()
{
    QList<WeightList> result;
    WeightList item;
    item << 1;
    result << item;
    return result;
}

qreal Item::getWidth(const WeightList &)
{
    return preferredWidth();
}

void Item::adjustWidth(const WeightList &)
{

}

} // namespace Korat

#include "koratitem.moc"
// vim: sw=4 sts=4 et tw=100
