#ifndef SHADOWITEM_H
#define SHADOWITEM_H

#include <QGraphicsPixmapItem>


class ShadowItem : public QGraphicsPixmapItem
{
public:
    ShadowItem();

    void setShadowParent(QGraphicsItem *item);
    QGraphicsItem *shadowParent() const;
    void generate();
    void adjustPosition();

private:
    QGraphicsItem *m_shadowParent;
};

#endif
